# BEGIN LICENSE BLOCK
# 
# Copyright (c) 1996-2003 Jesse Vincent <jesse@bestpractical.com>
# 
# (Except where explictly superceded by other copyright notices)
# 
# This work is made available to you under the terms of Version 2 of
# the GNU General Public License. A copy of that license should have
# been provided with this software, but in any event can be snarfed
# from www.gnu.org.
# 
# This work is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# Unless otherwise specified, all modifications, corrections or
# extensions to this work which alter its source code become the
# property of Best Practical Solutions, LLC when submitted for
# inclusion in the work.
# 
# 
# END LICENSE BLOCK
package RT::URI::cm;

use lib ("/opt/nettools/rt/lib");

use RT::Ticket;

use RT::URI::base;

use strict;
use vars qw(@ISA);
@ISA = qw/RT::URI::base/;

my $scheme = "cm";

=head2 ParseURI URI

When handed an fsck.com-rt: URI, figures out things like whether its a
CM reference or not.

=cut

sub ParseURI { 
    my $self = shift;
    my $uri = shift;

    # "cm:<ticketnum>#<title>"

    if ($uri =~ /^$scheme:(\d+)/) {
      $self->{'uri'} = $uri;
      $self->{'href'} =  $RT::AOLCM_URL . "/ViewTicket.do?ticketNum=$1";
      $self->{'cmtid'} = $1;

     # if we have a tiitle, use it to setup the pretty printer
      if ($uri =~ /\#(.+)$/) {
	$self->{'title'} = $1 . "(Change Mgmt " . $self->{'cmtid'} . ")";
      } else {
        $self->{'title'} = $uri;
      }

      return 1;
    }
    return undef;
    
}

     # ->URI must always return the _full_ URI -- not a cleaned up version.

=head2 Scheme

Return the URI scheme 

=cut

sub Scheme {
  return $scheme;
}

sub HREF {
  my $self = shift;
  return($self->{'href'});
}

sub AsString {
  my $self = shift;
  return($self->{'title'});
}

1;
